Index: pjproject/main/pjlib/include/pj++/string.hpp
===================================================================
--- pjproject/main/pjlib/include/pj++/string.hpp	(revision 35)
+++ pjproject/main/pjlib/include/pj++/string.hpp	(revision 36)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #ifndef __PJPP_STRING_H__
@@ -7,54 +6,89 @@
 #include <pj/string.h>
 #include <pj++/pool.hpp>
-
-class PJ_String : public pj_str_t
+#include <pj/assert.h>
+
+//
+// String wrapper class for pj_str_t.
+//
+class Pj_String : public pj_str_t
 {
 public:
-    PJ_String() 
+    //
+    // Default constructor.
+    //
+    Pj_String() 
     { 
-	pj_assert(sizeof(PJ_String) == sizeof(pj_str_t));
-	ptr=NULL; slen=0; 
-    }
-
-    explicit PJ_String(char *str) 
+	pj_assert(sizeof(Pj_String) == sizeof(pj_str_t));
+	ptr=NULL; 
+        slen=0; 
+    }
+
+    //
+    // Construct the buffer from a char*.
+    //
+    explicit Pj_String(char *str) 
     { 
 	set(str);
     }
 
-    PJ_String(PJ_Pool *pool, const char *src)
+    //
+    // Construct from a const char*.
+    //
+    Pj_String(Pj_Pool *pool, const char *src)
     {
 	set(pool, src);
     }
 
-    explicit PJ_String(pj_str_t *s)
+    //
+    // Construct from pj_str_t*.
+    //
+    explicit Pj_String(pj_str_t *s)
     {
 	set(s);
     }
 
-    PJ_String(PJ_Pool *pool, const pj_str_t *s)
+    //
+    // Construct by copying from const pj_str_t*.
+    //
+    Pj_String(Pj_Pool *pool, const pj_str_t *s)
     {
 	set(pool, s);
     }
 
-    explicit PJ_String(PJ_String &rhs)
+    //
+    // Construct from another Pj_String
+    //
+    explicit Pj_String(Pj_String &rhs)
     {
 	set(rhs);
     }
 
-    PJ_String(PJ_Pool *pool, const PJ_String &rhs)
+    //
+    // Construct by copying from Pj_String
+    //
+    Pj_String(Pj_Pool *pool, const Pj_String &rhs)
     {
 	set(pool, rhs);
     }
 
-    PJ_String(char *str, pj_size_t len)
+    //
+    // Construct from a char* and a length.
+    //
+    Pj_String(char *str, pj_size_t len)
     {
 	set(str, len);
     }
 
-    PJ_String(char *begin, char *end)
+    //
+    // Construct from pair of pointer.
+    //
+    Pj_String(char *begin, char *end)
     {
 	pj_strset3(this, begin, end);
     }
 
+    //
+    // Get the length of the string.
+    //
     pj_size_t length() const
     {
@@ -62,4 +96,7 @@
     }
 
+    //
+    // Get the length of the string.
+    //
     pj_size_t size() const
     {
@@ -67,4 +104,7 @@
     }
 
+    //
+    // Get the string buffer.
+    //
     const char *buf() const
     {
@@ -72,4 +112,7 @@
     }
 
+    //
+    // Initialize buffer from char*.
+    //
     void set(char *str)
     {
@@ -77,9 +120,15 @@
     }
 
-    void set(PJ_Pool *pool, const char *s)
+    //
+    // Initialize by copying from a const char*.
+    //
+    void set(Pj_Pool *pool, const char *s)
     {
 	pj_strdup2(pool->pool_(), this, s);
     }
 
+    //
+    // Initialize from pj_str_t*.
+    //
     void set(pj_str_t *s)
     {
@@ -87,9 +136,15 @@
     }
 
-    void set(PJ_Pool *pool, const pj_str_t *s)
+    //
+    // Initialize by copying from const pj_str_t*.
+    //
+    void set(Pj_Pool *pool, const pj_str_t *s)
     {
 	pj_strdup(pool->pool_(), this, s);
     }
 
+    //
+    // Initialize from char* and length.
+    //
     void set(char *str, pj_size_t len)
     {
@@ -97,4 +152,7 @@
     }
 
+    //
+    // Initialize from pair of pointers.
+    //
     void set(char *begin, char *end)
     {
@@ -102,19 +160,31 @@
     }
 
-    void set(PJ_String &rhs)
+    //
+    // Initialize from other Pj_String.
+    //
+    void set(Pj_String &rhs)
     {
 	pj_strassign(this, &rhs);
     }
 
-    void set(PJ_Pool *pool, const PJ_String *s)
+    //
+    // Initialize by copying from a Pj_String*.
+    //
+    void set(Pj_Pool *pool, const Pj_String *s)
     {
 	pj_strdup(pool->pool_(), this, s);
     }
 
-    void set(PJ_Pool *pool, const PJ_String &s)
+    //
+    // Initialize by copying from other Pj_String.
+    //
+    void set(Pj_Pool *pool, const Pj_String &s)
     {
 	pj_strdup(pool->pool_(), this, &s);
     }
 
+    //
+    // Copy the contents of other string.
+    //
     void strcpy(const pj_str_t *s)
     {
@@ -122,9 +192,15 @@
     }
 
-    void strcpy(const PJ_String &rhs)
+    //
+    // Copy the contents of other string.
+    //
+    void strcpy(const Pj_String &rhs)
     {
 	pj_strcpy(this, &rhs);
     }
 
+    //
+    // Copy the contents of other string.
+    //
     void strcpy(const char *s)
     {
@@ -132,4 +208,7 @@
     }
 
+    //
+    // Compare string.
+    //
     int strcmp(const char *s) const
     {
@@ -137,4 +216,7 @@
     }
 
+    //
+    // Compare string.
+    //
     int strcmp(const pj_str_t *s) const
     {
@@ -142,9 +224,15 @@
     }
 
-    int strcmp(const PJ_String &rhs) const
+    //
+    // Compare string.
+    //
+    int strcmp(const Pj_String &rhs) const
     {
 	return pj_strcmp(this, &rhs);
     }
 
+    //
+    // Compare string.
+    //
     int strncmp(const char *s, pj_size_t len) const
     {
@@ -152,4 +240,7 @@
     }
 
+    //
+    // Compare string.
+    //
     int strncmp(const pj_str_t *s, pj_size_t len) const
     {
@@ -157,9 +248,15 @@
     }
 
-    int strncmp(const PJ_String &rhs, pj_size_t len) const
+    //
+    // Compare string.
+    //
+    int strncmp(const Pj_String &rhs, pj_size_t len) const
     {
 	return pj_strncmp(this, &rhs, len);
     }
 
+    //
+    // Compare string.
+    //
     int stricmp(const char *s) const
     {
@@ -167,4 +264,7 @@
     }
 
+    //
+    // Compare string.
+    //
     int stricmp(const pj_str_t *s) const
     {
@@ -172,9 +272,15 @@
     }
 
-    int stricmp(const PJ_String &rhs) const
+    //
+    // Compare string.
+    //
+    int stricmp(const Pj_String &rhs) const
     {
 	return stricmp(&rhs);
     }
 
+    //
+    // Compare string.
+    //
     int strnicmp(const char *s, pj_size_t len) const
     {
@@ -182,4 +288,7 @@
     }
 
+    //
+    // Compare string.
+    //
     int strnicmp(const pj_str_t *s, pj_size_t len) const
     {
@@ -187,9 +296,15 @@
     }
 
-    int strnicmp(const PJ_String &rhs, pj_size_t len) const
+    //
+    // Compare string.
+    //
+    int strnicmp(const Pj_String &rhs, pj_size_t len) const
     {
 	return strnicmp(&rhs, len);
     }
 
+    //
+    // Compare contents for equality.
+    //
     bool operator==(const char *s) const
     {
@@ -197,4 +312,7 @@
     }
 
+    //
+    // Compare contents for equality.
+    //
     bool operator==(const pj_str_t *s) const
     {
@@ -202,9 +320,15 @@
     }
 
-    bool operator==(const PJ_String &rhs) const
+    //
+    // Compare contents for equality.
+    //
+    bool operator==(const Pj_String &rhs) const
     {
 	return pj_strcmp(this, &rhs) == 0;
     }
 
+    //
+    // Find a character in the string.
+    //
     char *strchr(int chr)
     {
@@ -212,4 +336,7 @@
     }
 
+    //
+    // Find a character in the string.
+    //
     char *find(int chr)
     {
@@ -217,9 +344,15 @@
     }
 
-    void strcat(const PJ_String &rhs)
+    //
+    // Concatenate string.
+    //
+    void strcat(const Pj_String &rhs)
     {
 	pj_strcat(this, &rhs);
     }
 
+    //
+    // Left trim.
+    //
     void ltrim()
     {
@@ -227,4 +360,7 @@
     }
 
+    //
+    // Right trim.
+    //
     void rtrim()
     {
@@ -232,4 +368,7 @@
     }
 
+    //
+    // Left and right trim.
+    //
     void trim()
     {
@@ -237,12 +376,32 @@
     }
 
-    unsigned long toul() const
+    //
+    // Convert to unsigned long.
+    //
+    unsigned long to_ulong() const
     {
 	return pj_strtoul(this);
     }
 
+    //
+    // Convert from unsigned long.
+    //
+    void from_ulong(unsigned long value)
+    {
+        slen = pj_utoa(value, ptr);
+    }
+
+    //
+    // Convert from unsigned long with padding.
+    //
+    void from_ulong_with_pad(unsigned long value, int min_dig=0, int pad=' ')
+    {
+        slen = pj_utoa_pad(value, ptr, min_dig, pad);
+    }
+
+
 private:
-    //PJ_String(const PJ_String &rhs) {}
-    void operator=(const PJ_String &rhs) { pj_assert(false); }
+    //Pj_String(const Pj_String &rhs) {}
+    void operator=(const Pj_String &rhs) { pj_assert(false); }
 };
 
Index: pjproject/main/pjlib/include/pj++/timer.hpp
===================================================================
--- pjproject/main/pjlib/include/pj++/timer.hpp	(revision 35)
+++ pjproject/main/pjlib/include/pj++/timer.hpp	(revision 36)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #ifndef __PJPP_TIMER_H__
@@ -7,68 +6,107 @@
 #include <pj/timer.h>
 #include <pj++/types.hpp>
+#include <pj/assert.h>
+#include <pj++/lock.hpp>
 
-class PJ_Timer_Heap;
+class Pj_Timer_Heap;
 
-class PJ_Timer_Entry : private pj_timer_entry
+//////////////////////////////////////////////////////////////////////////////
+// Timer entry.
+//
+// How to use:
+//  Derive class from Pj_Timer_Entry and override on_timeout().
+//  Scheduler timer in Pj_Timer_Heap.
+//
+class Pj_Timer_Entry : public Pj_Object
 {
-    friend class PJ_Timer_Heap;
+    friend class Pj_Timer_Heap;
 
 public:
-    static void timer_heap_callback(pj_timer_heap_t *, pj_timer_entry *);
-
-    PJ_Timer_Entry() { cb = &timer_heap_callback; }
-    PJ_Timer_Entry(int arg_id, void *arg_user_data)
-    {
-	cb = &timer_heap_callback; 
-	init(arg_id, arg_user_data);
+    //
+    // Default constructor.
+    //
+    Pj_Timer_Entry() 
+    { 
+        entry_.user_data = this;
+        entry_.cb = &timer_heap_callback; 
     }
 
-    virtual void on_timeout() = 0;
-
-    void init(int arg_id, void *arg_user_data)
+    //
+    // Destructor, do nothing.
+    //
+    ~Pj_Timer_Entry()
     {
-	id = arg_id;
-	user_data = arg_user_data;
     }
 
-    int get_id() const
+    //
+    // Override this to get the timeout notification.
+    //
+    virtual void on_timeout(int id) = 0;
+
+private:
+    pj_timer_entry entry_;
+
+    static void timer_heap_callback(pj_timer_heap_t *th, pj_timer_entry *e)
     {
-	return id;
+        Pj_Timer_Entry *entry = (Pj_Timer_Entry*) e->user_data;
+        entry->on_timeout(e->id);
     }
 
-    void set_id(int arg_id)
+};
+
+//////////////////////////////////////////////////////////////////////////////
+// Timer heap.
+//
+class Pj_Timer_Heap : public Pj_Object
+{
+public:
+    //
+    // Default constructor.
+    //
+    Pj_Timer_Heap() 
+        : ht_(NULL) 
     {
-	id = arg_id;
     }
 
-    void set_user_data(void *arg_user_data)
+    //
+    // Construct timer heap.
+    //
+    Pj_Timer_Heap(Pj_Pool *pool, pj_size_t initial_count)
+        : ht_(NULL)
     {
-	user_data = arg_user_data;
+        create(pool, initial_count);
     }
 
-    void *get_user_data() const
+    //
+    // Destructor.
+    //
+    ~Pj_Timer_Heap()
     {
-	return user_data;
+        destroy();
     }
 
-    const PJ_Time_Val &get_timeout() const
+    //
+    // Create
+    // 
+    pj_status_t create(Pj_Pool *pool, pj_size_t initial_count)
     {
-	pj_assert(sizeof(PJ_Time_Val) == sizeof(pj_time_val));
-	return (PJ_Time_Val&)_timer_value;
-    }
-};
-
-class PJ_Timer_Heap
-{
-public:
-    PJ_Timer_Heap() {}
-
-    bool create(PJ_Pool *pool, pj_size_t initial_count, 
-		unsigned flag = PJ_TIMER_HEAP_SYNCHRONIZE)
-    {
-	ht_ = pj_timer_heap_create(pool->pool_(), initial_count, flag);
-	return ht_ != NULL;
+        destroy();
+	return pj_timer_heap_create(pool->pool_(), initial_count, &ht_);
     }
 
+    //
+    // Destroy
+    //
+    void destroy()
+    {
+        if (ht_) {
+            pj_timer_heap_destroy(ht_);
+            ht_ = NULL;
+        }
+    }
+
+    //
+    // Get pjlib compatible timer heap object.
+    //
     pj_timer_heap_t *get_timer_heap()
     {
@@ -76,14 +114,41 @@
     }
 
-    bool schedule( PJ_Timer_Entry *ent, const PJ_Time_Val &delay)
+    //
+    // Set the lock object.
+    //
+    void set_lock( Pj_Lock *lock, bool auto_delete )
     {
-	return pj_timer_heap_schedule(ht_, ent, &delay) == 0;
+        pj_timer_heap_set_lock( ht_, lock->pj_lock_t_(), auto_delete);
     }
 
-    bool cancel(PJ_Timer_Entry *ent)
+    //
+    // Set maximum number of timed out entries to be processed per poll.
+    //
+    unsigned set_max_timed_out_per_poll(unsigned count)
     {
-	return pj_timer_heap_cancel(ht_, ent) == 1;
+        return pj_timer_heap_set_max_timed_out_per_poll(ht_, count);
     }
 
+    //
+    // Schedule a timer.
+    //
+    bool schedule( Pj_Timer_Entry *ent, const Pj_Time_Val &delay,
+                   int id)
+    {
+        ent->entry_.id = id;
+	return pj_timer_heap_schedule(ht_, &ent->entry_, &delay) == 0;
+    }
+
+    //
+    // Cancel a timer.
+    //
+    bool cancel(Pj_Timer_Entry *ent)
+    {
+	return pj_timer_heap_cancel(ht_, &ent->entry_) == 1;
+    }
+
+    //
+    // Get current number of timers
+    //
     pj_size_t count()
     {
@@ -91,10 +156,18 @@
     }
 
-    void earliest_time(PJ_Time_Val *t)
+    //
+    // Get the earliest time.
+    // Return false if no timer is found.
+    //
+    bool earliest_time(Pj_Time_Val *t)
     {
-	pj_timer_heap_earliest_time(ht_, t);
+	return pj_timer_heap_earliest_time(ht_, t) == PJ_SUCCESS;
     }
 
-    int poll(PJ_Time_Val *next_delay = NULL)
+    //
+    // Poll the timer.
+    // Return number of timed out entries has been called.
+    //
+    unsigned poll(Pj_Time_Val *next_delay = NULL)
     {
 	return pj_timer_heap_poll(ht_, next_delay);
Index: pjproject/main/pjlib/include/pj++/tree.hpp
===================================================================
--- pjproject/main/pjlib/include/pj++/tree.hpp	(revision 35)
+++ pjproject/main/pjlib/include/pj++/tree.hpp	(revision 36)
@@ -7,4 +7,7 @@
 #include <pj/rbtree.h>
 
+//
+// Tree.
+//
 class PJ_Tree
 {
Index: pjproject/main/pjlib/include/pj++/types.hpp
===================================================================
--- pjproject/main/pjlib/include/pj++/types.hpp	(revision 35)
+++ pjproject/main/pjlib/include/pj++/types.hpp	(revision 36)
@@ -7,28 +7,106 @@
 #include <pj/types.h>
 
-class PJ_Pool;
-class PJ_Socket;
+class Pj_Pool;
+class Pj_Socket ;
+class Pj_Lock;
 
 
-class PJ_Time_Val : public pj_time_val
+//
+// PJLIB initializer.
+//
+class Pjlib
 {
 public:
-    PJ_Time_Val() {}
-    PJ_Time_Val(const PJ_Time_Val &rhs) { sec=rhs.sec; msec=rhs.msec; }
-    explicit PJ_Time_Val(const pj_time_val &tv) { sec = tv.sec; msec = tv.msec; }
+    Pjlib()
+    {
+        pj_init();
+    }
+};
 
-    long get_sec()  const    { return sec; }
-    long get_msec() const    { return msec; }
-    void set_sec (long s)    { sec = s; }
-    void set_msec(long ms)   { msec = ms; normalize(); }
-    long to_msec() const { return PJ_TIME_VAL_MSEC((*this)); }
+//
+// Class Pj_Object is declared in pool.hpp
+//
 
-    bool operator == (const PJ_Time_Val &rhs) const { return PJ_TIME_VAL_EQ((*this), rhs);  }
-    bool operator >  (const PJ_Time_Val &rhs) const { return PJ_TIME_VAL_GT((*this), rhs);  }
-    bool operator >= (const PJ_Time_Val &rhs) const { return PJ_TIME_VAL_GTE((*this), rhs); }
-    bool operator <  (const PJ_Time_Val &rhs) const { return PJ_TIME_VAL_LT((*this), rhs);  }
-    bool operator <= (const PJ_Time_Val &rhs) const { return PJ_TIME_VAL_LTE((*this), rhs); }
+//
+// Time value wrapper.
+//
+class Pj_Time_Val : public pj_time_val
+{
+public:
+    Pj_Time_Val()
+    {
+    }
 
-    PJ_Time_Val & operator = (const PJ_Time_Val &rhs) {
+    Pj_Time_Val(long init_sec, long init_msec)
+    {
+        sec = init_sec;
+        msec = init_msec;
+    }
+
+    Pj_Time_Val(const Pj_Time_Val &rhs) 
+    { 
+        sec=rhs.sec; 
+        msec=rhs.msec; 
+    }
+
+    explicit Pj_Time_Val(const pj_time_val &tv) 
+    { 
+        sec = tv.sec; 
+        msec = tv.msec; 
+    }
+
+    long get_sec()  const    
+    { 
+        return sec; 
+    }
+
+    long get_msec() const    
+    { 
+        return msec; 
+    }
+
+    void set_sec (long s)    
+    { 
+        sec = s; 
+    }
+
+    void set_msec(long ms)   
+    { 
+        msec = ms; 
+        normalize(); 
+    }
+
+    long to_msec() const 
+    { 
+        return PJ_TIME_VAL_MSEC((*this)); 
+    }
+
+    bool operator == (const Pj_Time_Val &rhs) const 
+    { 
+        return PJ_TIME_VAL_EQ((*this), rhs);  
+    }
+
+    bool operator >  (const Pj_Time_Val &rhs) const 
+    { 
+        return PJ_TIME_VAL_GT((*this), rhs);  
+    }
+
+    bool operator >= (const Pj_Time_Val &rhs) const 
+    { 
+        return PJ_TIME_VAL_GTE((*this), rhs); 
+    }
+
+    bool operator <  (const Pj_Time_Val &rhs) const 
+    { 
+        return PJ_TIME_VAL_LT((*this), rhs);  
+    }
+
+    bool operator <= (const Pj_Time_Val &rhs) const 
+    { 
+        return PJ_TIME_VAL_LTE((*this), rhs); 
+    }
+
+    Pj_Time_Val & operator = (const Pj_Time_Val &rhs) 
+    {
 	sec = rhs.sec;
 	msec = rhs.msec;
@@ -36,10 +114,12 @@
     }
  
-    PJ_Time_Val & operator += (const PJ_Time_Val &rhs) {
+    Pj_Time_Val & operator += (const Pj_Time_Val &rhs) 
+    {
 	PJ_TIME_VAL_ADD((*this), rhs);
 	return *this;
     }
 
-    PJ_Time_Val & operator -= (const PJ_Time_Val &rhs) {
+    Pj_Time_Val & operator -= (const Pj_Time_Val &rhs) 
+    {
 	PJ_TIME_VAL_SUB((*this), rhs);
 	return *this;
@@ -47,13 +127,16 @@
 
     /* Must include os.hpp to use these, otherwise unresolved in linking */
-    pj_status_t	   gettimeofday();
-    pj_parsed_time decode();
-    pj_status_t    encode(const pj_parsed_time *pt);
-    pj_status_t    to_gmt();
-    pj_status_t    to_local();
+    inline pj_status_t	   gettimeofday();
+    inline pj_parsed_time  decode();
+    inline pj_status_t     encode(const pj_parsed_time *pt);
+    inline pj_status_t     to_gmt();
+    inline pj_status_t     to_local();
 
 
 private:
-    void normalize() { pj_time_val_normalize(this); }
+    void normalize() 
+    { 
+        pj_time_val_normalize(this); 
+    }
 
 };
Index: pjproject/main/pjlib/include/pj/errno.h
===================================================================
--- pjproject/main/pjlib/include/pj/errno.h	(revision 35)
+++ pjproject/main/pjlib/include/pj/errno.h	(revision 36)
@@ -211,4 +211,9 @@
  */
 #define PJ_EINVALIDOP	    (PJ_ERRNO_START_STATUS + 13)
+/**
+ * @hideinitializer
+ * Operation is cancelled.
+ */
+#define PJ_ECANCELLED	    (PJ_ERRNO_START_STATUS + 14)
 
 /** @} */   /* pj_errnum */
Index: pjproject/main/pjlib/include/pj/ioqueue.h
===================================================================
--- pjproject/main/pjlib/include/pj/ioqueue.h	(revision 35)
+++ pjproject/main/pjlib/include/pj/ioqueue.h	(revision 36)
@@ -298,12 +298,17 @@
 /**
  * Unregister from the I/O Queue framework. Caller must make sure that
- * the key doesn't have any pending operation before calling this function,
- * or otherwise the behaviour is undefined (either callback will be called
- * later when the data is sent/received, or the callback will not be called,
- * or even something else).
+ * the key doesn't have any pending operations before calling this function,
+ * by calling #pj_ioqueue_is_pending() for all previously submitted
+ * operations except asynchronous connect, and if necessary call
+ * #pj_ioqueue_post_completion() to cancel the pending operations.
+ *
+ * Note that asynchronous connect operation will automatically be 
+ * cancelled during the unregistration.
  *
  * @param key	    The key that was previously obtained from registration.
  *
  * @return          PJ_SUCCESS on success or the error code.
+ *
+ * @see pj_ioqueue_is_pending
  */
 PJ_DECL(pj_status_t) pj_ioqueue_unregister( pj_ioqueue_key_t *key );
@@ -334,4 +339,39 @@
                                                void *user_data,
                                                void **old_data);
+
+
+/**
+ * Check if operation is pending on the specified operation key.
+ * The \c op_key must have been submitted as pending operation before,
+ * or otherwise the result is undefined.
+ *
+ * @param key       The key.
+ * @param op_key    The operation key, previously submitted to any of
+ *                  the I/O functions and has returned PJ_EPENDING.
+ *
+ * @return          Non-zero if operation is still pending.
+ */
+PJ_DECL(pj_bool_t) pj_ioqueue_is_pending( pj_ioqueue_key_t *key,
+                                          pj_ioqueue_op_key_t *op_key );
+
+
+/**
+ * Post completion status to the specified operation key and call the
+ * appropriate callback. When the callback is called, the number of bytes 
+ * received in read/write callback or the status in accept/connect callback
+ * will be set from the \c bytes_status parameter.
+ *
+ * @param key           The key.
+ * @param op_key        Pending operation key.
+ * @param bytes_status  Number of bytes or status to be set. A good value
+ *                      to put here is -PJ_ECANCELLED.
+ *
+ * @return              PJ_SUCCESS if completion status has been successfully
+ *                      sent.
+ */
+PJ_DECL(pj_status_t) pj_ioqueue_post_completion( pj_ioqueue_key_t *key,
+                                                 pj_ioqueue_op_key_t *op_key,
+                                                 pj_ssize_t bytes_status );
+
 
 
Index: pjproject/main/pjlib/include/pj/os.h
===================================================================
--- pjproject/main/pjlib/include/pj/os.h	(revision 35)
+++ pjproject/main/pjlib/include/pj/os.h	(revision 36)
@@ -326,4 +326,13 @@
 
 /**
+ * Increment the value of an atomic type and get the result.
+ *
+ * @param atomic_var	the atomic variable.
+ *
+ * @return              The incremented value.
+ */
+PJ_DECL(pj_atomic_value_t) pj_atomic_inc_and_get(pj_atomic_t *atomic_var);
+
+/**
  * Decrement the value of an atomic type.
  *
@@ -331,4 +340,13 @@
  */
 PJ_DECL(void) pj_atomic_dec(pj_atomic_t *atomic_var);
+
+/**
+ * Decrement the value of an atomic type and get the result.
+ *
+ * @param atomic_var	the atomic variable.
+ *
+ * @return              The decremented value.
+ */
+PJ_DECL(pj_atomic_value_t) pj_atomic_dec_and_get(pj_atomic_t *atomic_var);
 
 /**
@@ -340,4 +358,15 @@
 PJ_DECL(void) pj_atomic_add( pj_atomic_t *atomic_var,
 			     pj_atomic_value_t value);
+
+/**
+ * Add a value to an atomic type and get the result.
+ *
+ * @param atomic_var	The atomic variable.
+ * @param value		Value to be added.
+ *
+ * @return              The result after the addition.
+ */
+PJ_DECL(pj_atomic_value_t) pj_atomic_add_and_get( pj_atomic_t *atomic_var,
+			                          pj_atomic_value_t value);
 
 /**
Index: pjproject/main/pjlib/include/pj/timer.h
===================================================================
--- pjproject/main/pjlib/include/pj/timer.h	(revision 35)
+++ pjproject/main/pjlib/include/pj/timer.h	(revision 36)
@@ -111,16 +111,4 @@
 
 /**
- * Default flag for timer heap, indicates that synchronization will be
- * used.
- */
-#define PJ_TIMER_HEAP_SYNCHRONIZE	(0)
-
-/**
- * Flag to indicate that thread synchronization is NOT needed for the 
- * timer heap.
- */
-#define PJ_TIMER_HEAP_NO_SYNCHRONIZE	(1)
-
-/**
  * Calculate memory size required to create a timer heap.
  *
@@ -141,6 +129,4 @@
  *                  initially. If the application registers more entries 
  *                  during runtime, then the timer heap will resize.
- * @param flag      Creation flag, currently only PJ_TIMER_HEAP_NO_SYNCHRONIZE
- *                  is recognized..
  * @param ht        Pointer to receive the created timer heap.
  *
@@ -149,6 +135,37 @@
 PJ_DECL(pj_status_t) pj_timer_heap_create( pj_pool_t *pool,
 					   pj_size_t count,
-					   unsigned flag,
                                            pj_timer_heap_t **ht);
+
+/**
+ * Destroy the timer heap.
+ *
+ * @param ht        The timer heap.
+ */
+PJ_DECL(void) pj_timer_heap_destroy( pj_timer_heap_t *ht );
+
+
+/**
+ * Set lock object to be used by the timer heap. By default, the timer heap
+ * uses dummy synchronization.
+ *
+ * @param ht        The timer heap.
+ * @param lock      The lock object to be used for synchronization.
+ * @param auto_del  If nonzero, the lock object will be destroyed when
+ *                  the timer heap is destroyed.
+ */
+PJ_DECL(void) pj_timer_heap_set_lock( pj_timer_heap_t *ht,
+                                      pj_lock_t *lock,
+                                      pj_bool_t auto_del );
+
+/**
+ * Set maximum number of timed out entries to process in a single poll.
+ *
+ * @param ht        The timer heap.
+ * @param count     Number of entries.
+ *
+ * @return          The old number.
+ */
+PJ_DECL(unsigned) pj_timer_heap_set_max_timed_out_per_poll(pj_timer_heap_t *ht,
+                                                           unsigned count );
 
 /**
@@ -216,5 +233,5 @@
  */
 PJ_DECL(pj_status_t) pj_timer_heap_earliest_time( pj_timer_heap_t *ht, 
-					   pj_time_val *timeval);
+					          pj_time_val *timeval);
 
 /**
@@ -222,11 +239,13 @@
  * each of the expired timers.
  *
- * @param ht        The timer heap.
+ * @param ht         The timer heap.
  * @param next_delay If this parameter is not NULL, it will be filled up with
  *		     the time delay until the next timer elapsed, or -1 in
  *		     the sec part if no entry exist.
- * @return          The number of timers expired.
- */
-PJ_DECL(int) pj_timer_heap_poll( pj_timer_heap_t *ht, pj_time_val *next_delay);
+ *
+ * @return           The number of timers expired.
+ */
+PJ_DECL(unsigned) pj_timer_heap_poll( pj_timer_heap_t *ht, 
+                                      pj_time_val *next_delay);
 
 /**
Index: pjproject/main/pjlib/src/pj/errno.c
===================================================================
--- pjproject/main/pjlib/src/pj/errno.c	(revision 35)
+++ pjproject/main/pjlib/src/pj/errno.c	(revision 36)
@@ -30,5 +30,6 @@
     { PJ_EBUSY,         "Object is busy"},
     { PJ_ENOTSUP,	"Option/operation is not supported"},
-    { PJ_EINVALIDOP,	"Invalid operation"}
+    { PJ_EINVALIDOP,	"Invalid operation"},
+    { PJ_ECANCELLED,    "Operation cancelled"}
 };
 
Index: pjproject/main/pjlib/src/pj/file_io_ansi.c
===================================================================
--- pjproject/main/pjlib/src/pj/file_io_ansi.c	(revision 35)
+++ pjproject/main/pjlib/src/pj/file_io_ansi.c	(revision 36)
@@ -68,4 +68,5 @@
     written = fwrite(data, 1, *size, (FILE*)fd);
     if (ferror((FILE*)fd)) {
+        *size = -1;
         return PJ_RETURN_OS_ERROR(errno);
     }
@@ -84,4 +85,5 @@
     bytes = fread(data, 1, *size, (FILE*)fd);
     if (ferror((FILE*)fd)) {
+        *size = -1;
         return PJ_RETURN_OS_ERROR(errno);
     }
